=== modified file 'plugin/haildb/haildb_engine.cc'
--- plugin/haildb/haildb_engine.cc	2010-12-02 00:50:20 +0000
+++ plugin/haildb/haildb_engine.cc	2010-12-02 00:59:53 +0000
@@ -2827,7 +2827,6 @@
 static bool innobase_create_status_file;
 static bool srv_use_sys_malloc;
 static string innobase_file_format_name;
-static unsigned long srv_max_purge_lag;
 static unsigned long innobase_read_io_threads;
 static unsigned long innobase_write_io_threads;
 typedef constrained_check<unsigned int, 1000, 1> autoextend_constraint;
@@ -2858,6 +2857,8 @@
 static lru_old_blocks_constraint innobase_lru_old_blocks_pct;
 typedef constrained_check<unsigned int, 99, 0> max_dirty_pages_constraint;
 static max_dirty_pages_constraint haildb_max_dirty_pages_pct;
+typedef constrained_check<uint64_t, UINT64_MAX, 0> max_purge_lag_constraint;
+static max_purge_lag_constraint haildb_max_purge_lag;
 
 
 static uint32_t innobase_lru_block_access_recency;
@@ -2928,15 +2929,6 @@
   srv_use_sys_malloc= (vm.count("use-internal-malloc")) ? false : true;
 
 
-  if (vm.count("max-purge-lag"))
-  {
-    if (srv_max_purge_lag > (unsigned long)~0L)
-    {
-      errmsg_printf(ERRMSG_LVL_ERROR, _("Invalid value of max-purge-lag"));
-      return 1;
-    }
-  }
-
   if (vm.count("open-files"))
   {
     if (innobase_open_files > LONG_MAX || innobase_open_files < 10L)
@@ -3095,7 +3087,7 @@
   if (err != DB_SUCCESS)
     goto haildb_error;
 
-  err= ib_cfg_set_int("max_purge_lag", srv_max_purge_lag);
+  err= ib_cfg_set_int("max_purge_lag", haildb_max_purge_lag.get());
   if (err != DB_SUCCESS)
     goto haildb_error;
 
@@ -3177,6 +3169,7 @@
                                                     &innobase_lru_block_access_recency,
                                                     haildb_lru_block_access_recency_update));
   context.registerVariable(new sys_var_constrained_value_readonly<unsigned int>("max_dirty_pages_pct", haildb_max_dirty_pages_pct));
+  context.registerVariable(new sys_var_constrained_value_readonly<uint64_t>("max_purge_lag", haildb_max_purge_lag));
 
   haildb_datadict_dump_func_initialize(context);
   config_table_function_initialize(context);
@@ -3211,11 +3204,6 @@
 
 
 
-static DRIZZLE_SYSVAR_ULONG(max_purge_lag, srv_max_purge_lag,
-  PLUGIN_VAR_RQCMDARG,
-  "Desired maximum length of the purge queue (0 = no limit)",
-  NULL, NULL, 0, 0, ~0L, 0);
-
 static DRIZZLE_SYSVAR_LONG(open_files, innobase_open_files,
   PLUGIN_VAR_RQCMDARG | PLUGIN_VAR_READONLY,
   "How many files at the maximum HailDB keeps open at the same time.",
@@ -3307,7 +3295,7 @@
           po::value<max_dirty_pages_constraint>(&haildb_max_dirty_pages_pct)->default_value(75),
           N_("Percentage of dirty pages allowed in bufferpool."));
   context("max-purge-lag",
-          po::value<unsigned long>(&srv_max_purge_lag)->default_value(0),
+          po::value<max_purge_lag_constraint>(&haildb_max_purge_lag)->default_value(0),
           N_("Desired maximum length of the purge queue (0 = no limit)"));
   context("rollback-on-timeout",
           po::value<bool>(&innobase_rollback_on_timeout)->default_value(false)->zero_tokens(),
@@ -3334,7 +3322,6 @@
 }
 
 static drizzle_sys_var* innobase_system_variables[]= {
-  DRIZZLE_SYSVAR(max_purge_lag),
   DRIZZLE_SYSVAR(open_files),
   DRIZZLE_SYSVAR(read_io_threads),
   DRIZZLE_SYSVAR(write_io_threads),

